; memmove
;   AAA=str
;   BBB=016
;   F=
;   O=
; str016.asm

.xlist
INCLUDE CLIBC_16.INC
.list

IFDEF CLIBC_16_EXTERN_PTRS
 IF CLIBC_16_EXTERN_PTRS EQ CLIBC_16_EXTERN_PTRS_YES

CLIBC_16_EXTERN_PTRS_SEG_NAME SEGMENT
EXTERNDEF C p_fn_memmove:FN_CALL PTR
p_fn_memmove P_FN_CALL memmove
EXTERNDEF C p_fn_fc_memmove:FN_CALL PTR
p_fn_fc_memmove P_FN_CALL @memmove
EXTERNDEF C p_fn_memmove_sss:FN_CALL PTR
p_fn_memmove_sss P_FN_CALL memmove_sss
EXTERNDEF C p_fn_fc_memmove_sss:FN_CALL PTR
p_fn_fc_memmove_sss P_FN_CALL @memmove_sss
EXTERNDEF C p_fn_memmove_dss:FN_CALL PTR
p_fn_memmove_dss P_FN_CALL memmove_dss
EXTERNDEF C p_fn_fc_memmove_dss:FN_CALL PTR
p_fn_fc_memmove_dss P_FN_CALL @memmove_dss
CLIBC_16_EXTERN_PTRS_SEG_NAME ENDS

 ENDIF
ENDIF

;memmove() -- Copy memory block
;void __near * fn_call memmove(void __near * const, void __near * const, const int);
;GIVEN:
;   p_m1	near pointer, (dest) offset from ds
;   p_m2	near pointer, (source) offset from ds
;   num 	bytes to move
;RETURNS: (void __near *)
;   pointer	near pointer, offset from ds (p_m1)
;NOTES:
;   assumes that the pointer segments will never overlap or are equal
;   makes no assumptions concerning DF
;   returns without altering DF
CLIBC_16_FUNCTION_SEG_NAME SEGMENT
memmove PROC FN_CALL C USES es si di,
	    p_m1:NEAR16 PTR, p_m2:NEAR16 PTR, num:WORD
	    pushf

	    mov ax, ds
	    mov es, ax

	    mov di, [p_m1]	    ;es:DI = destination
	    mov si, [p_m2]	    ;ds:SI = source
	    mov cx, [num]	    ;CX = count

	    cmp di,si		    ;Make forward moves
	    jb @@normal		   ;normal
	    je @@done
	    ; reverse
	    std
	    add si, cx
	    add di, cx
	    dec si
	    dec di
	    jmp @@doit
@@normal:
	    cld
@@doit:
	    rep movs BYTE PTR es:[di], ds:[si]
	    ; done
@@done:
	    mov ax, [p_m1]
	    popf
	    ret
memmove ENDP
CLIBC_16_FUNCTION_SEG_NAME ENDS

;memmove() -- Copy memory block
;void __near * __farcall fn_call memmove(void __near * const, void __near * const, const int);
; __fastcall
; GIVEN:
;   BX	    p_m1, (dest) offset from ds
;   AX	    p_m2, (source) offset from ds
;   DX	    num
;RETURNS:
;   AX	    near pointer, offset from ds (p_m1)
;NOTES:
;   assumes that the pointer segments will never overlap or are equal
;   makes no assumptions concerning DF
;   returns without altering DF
CLIBC_16_FUNCTION_SEG_NAME SEGMENT
@memmove PROC FN_CALL USES es si di bx cx dx
	    pushf

	    mov di, bx		    ;es:DI = p_m1
	    mov si, ax		    ;ds:SI = p_m2
	    mov cx, dx		    ;cx = count
	    mov dx, bx		    ; dx = p_m1

	    mov ax, ds
	    mov es, ax

	    cmp di,si		    ;Make forward moves
	    jb @@normal		   ;normal
	    je @@done
	    ; reverse
	    std
	    add si, cx
	    add di, cx
	    dec si
	    dec di
	    jmp @@doit
@@normal:
	    cld
@@doit:
	    rep movs BYTE PTR es:[di], ds:[si]
	    ; done
@@done:
	    mov ax, dx
	    popf
	    ret
@memmove ENDP
CLIBC_16_FUNCTION_SEG_NAME ENDS

;memmove_sss() -- Copy memory block
;void __near * fn_call memmove_sss(void __near * const, void __near * const, const int);
;GIVEN:
;   p_m1	near pointer, (dest) offset from ds
;   p_m2	near pointer, (source) offset from ss
;   num 	bytes to move
;RETURNS: (void __near *)
;   pointer	near pointer, offset from ds (p_m1)
;NOTES:
;   assumes that the pointer segments will never overlap or are equal
;   makes no assumptions concerning DF
;   returns without altering DF
CLIBC_16_FUNCTION_SEG_NAME SEGMENT
memmove_sss PROC FN_CALL C USES ds es si di,
	    p_m1:NEAR16 PTR, p_m2:NEAR16 PTR, num:WORD
	    pushf

	    mov ax, ds
	    mov es, ax

	    mov di, [p_m1]	    ;es:DI = destination
	    mov si, [p_m2]	    ;ds:SI = source
	    mov cx, [num]	    ;CX = count

	    mov bx, ss
	    mov ds, bx
	    cmp ax, bx
	    je @@possiblerev
	    jmp @@doit
@@possiblerev:
	    cmp di,si		    ;Make forward moves
	    jb @@normal		   ;normal
	    je @@done
	    ; reverse
	    std
	    add si, cx
	    add di, cx
	    dec si
	    dec di
	    jmp @@doit
@@normal:
	    cld
@@doit:
	    rep movs BYTE PTR es:[di], ds:[si]
	    ; done
@@done:
	    mov ax, [p_m1]
	    popf
	    ret
memmove_sss ENDP
CLIBC_16_FUNCTION_SEG_NAME ENDS

;memmove_sss() -- Copy memory block
;void __near * __farcall fn_call memmove_sss(void __near * const, void __near * const, const int);
; __fastcall
; GIVEN:
;   BX	    p_m1, (dest) offset from ds
;   AX	    p_m2, (source) offset from ss
;   DX	    num
;RETURNS:
;   pointer	near pointer, offset from ds (p_m1)
;NOTES:
;   assumes that the pointer segments will never overlap or are equal
;   makes no assumptions concerning DF
;   returns without altering DF
CLIBC_16_FUNCTION_SEG_NAME SEGMENT
@memmove_sss PROC FN_CALL USES ds es si di bx cx dx
	    pushf

	    mov di, bx		    ;es:DI = p_m1
	    mov si, ax		    ;ds:SI = p_m2
	    mov cx, dx		    ;cx = count
	    mov dx, bx		    ; dx = p_m1

	    mov ax, ds
	    mov es, ax

	    mov bx, ss
	    mov ds, bx
	    cmp ax, bx
	    je @@possiblerev
	    jmp @@doit
@@possiblerev:
	    cmp di,si		    ;Make forward moves
	    jb @@normal		   ;normal
	    je @@done
	    ; reverse
	    std
	    add si, cx
	    add di, cx
	    dec si
	    dec di
	    jmp @@doit
@@normal:
	    cld
@@doit:
	    rep movs BYTE PTR es:[di], ds:[si]
	    ; done
@@done:
	    mov ax, dx
	    popf
	    ret
@memmove_sss ENDP
CLIBC_16_FUNCTION_SEG_NAME ENDS

;memmove_dss() -- Copy memory block
;void __near * fn_call memmove_dss(void __near * const, void __near * const, const int);
;GIVEN:
;   p_m1	near pointer, (dest) offset from ss
;   p_m2	near pointer, (source) offset from ds
;   num 	bytes to move
;RETURNS: (void __near *)
;   pointer	near pointer, offset from ss (p_m1)
;NOTES:
;   assumes that the pointer segments will never overlap or are equal
;   makes no assumptions concerning DF
;   returns without altering DF
CLIBC_16_FUNCTION_SEG_NAME SEGMENT
memmove_dss PROC FN_CALL C USES es si di,
	    p_m1:NEAR16 PTR, p_m2:NEAR16 PTR, num:WORD
	    pushf

	    mov ax, ss
	    mov es, ax

	    mov di, [p_m1]	    ;es:DI = destination
	    mov si, [p_m2]	    ;ds:SI = source
	    mov cx, [num]	    ;CX = count

	    mov ax, ds
	    mov bx, es
	    cmp ax, bx
	    je @@possiblerev
	    jmp @@doit
@@possiblerev:
	    cmp di,si		    ;Make forward moves
	    jb @@normal		   ;normal
	    je @@done
	    ; reverse
	    std
	    add si, cx
	    add di, cx
	    dec si
	    dec di
	    jmp @@doit
@@normal:
	    cld
@@doit:
	    rep movs BYTE PTR es:[di], ds:[si]
	    ; done
@@done:
	    mov ax, [p_m1]
	    popf
	    ret
memmove_dss ENDP
CLIBC_16_FUNCTION_SEG_NAME ENDS

;memmove_dss() -- Copy memory block
;void __near * __farcall fn_call memmove_dss(void __near * const, void __near * const, const int);
; __fastcall
; GIVEN:
;   BX	    p_m1, (dest) offset from ss
;   AX	    p_m2, (source) offset from ds
;   DX	    num
;RETURNS:
;   AX		near pointer, offset from ss (p_m1)
;NOTES:
;   assumes that the pointer segments will never overlap or are equal
;   makes no assumptions concerning DF
;   returns without altering DF
CLIBC_16_FUNCTION_SEG_NAME SEGMENT
@memmove_dss PROC FN_CALL USES es si di bx cx dx
	    pushf

	    mov di, bx		    ;es:DI = p_m1
	    mov si, ax		    ;ds:SI = p_m2
	    mov cx, dx		    ;cx = count
	    mov dx, bx		    ; dx = p_m1

	    mov ax, ss
	    mov es, ax

	    mov ax, ds
	    mov bx, es
	    cmp ax, bx
	    je @@possiblerev
	    jmp @@doit
@@possiblerev:
	    cmp di,si		    ;Make forward moves
	    jb @@normal		   ;normal
	    je @@done
	    ; reverse
	    std
	    add si, cx
	    add di, cx
	    dec si
	    dec di
	    jmp @@doit
@@normal:
	    cld
@@doit:
	    rep movs BYTE PTR es:[di], ds:[si]
	    ; done
@@done:
	    mov ax, dx
	    popf
	    ret
@memmove_dss ENDP
CLIBC_16_FUNCTION_SEG_NAME ENDS
END
