; memmove
;   AAA=str
;   BBB=016
;   F=0
;   O=0
; str01600.asm

.xlist
INCLUDE CLIBC_16.INC
.list

IFDEF CLIBC_16_EXTERN_PTRS
 IF CLIBC_16_EXTERN_PTRS EQ CLIBC_16_EXTERN_PTRS_YES

CLIBC_16_EXTERN_PTRS_SEG_NAME SEGMENT
EXTERNDEF C p_fn_memmove:FN_CALL PTR
p_fn_memmove P_FN_CALL memmove
CLIBC_16_EXTERN_PTRS_SEG_NAME ENDS

 ENDIF
ENDIF

;memmove() -- Copy memory block
;void __near * fn_call memmove(void __near * const, void __near * const, const int);
;GIVEN:
;   p_m1	near pointer, (dest) offset from ds
;   p_m2	near pointer, (source) offset from ds
;   num 	bytes to move
;RETURNS: (void __near *)
;   pointer	near pointer, offset from ds (p_m1)
;NOTES:
;   assumes that the pointer segments will never overlap or are equal
;   makes no assumptions concerning DF
;   returns without altering DF
BEGIN_CODE_SEGMENT <STRING>
memmove PROC FN_CALL C USES es si di,
	    p_m1:NEAR16 PTR, p_m2:NEAR16 PTR, num:WORD
	    pushf

	    mov ax, ds
	    mov es, ax

	    mov di, [p_m1]	    ;es:DI = destination
	    mov si, [p_m2]	    ;ds:SI = source
	    mov cx, [num]	    ;CX = count

	    cmp di,si		    ;Make forward moves
	    jb @@normal		   ;normal
	    je @@done
	    ; reverse
	    std
	    add si, cx
	    add di, cx
	    dec si
	    dec di
	    jmp @@doit
@@normal:
	    cld
@@doit:
	    rep movs BYTE PTR es:[di], ds:[si]
	    ; done
@@done:
	    mov ax, [p_m1]
	    popf
	    ret
memmove ENDP
END_CODE_SEGMENT <STRING>
END
